package tools.descartes.dql.connector.kieker.tests;

import static org.junit.Assert.*;

import org.eclipse.core.internal.utils.FileUtil;
import org.junit.Test;

import tools.descartes.dql.connector.kieker.PerformanceMetricsQueryConnectorImpl;
import tools.descartes.dql.models.mapping.domain.ContinuousSeriesResult;
import tools.descartes.dql.models.mapping.domain.DomainFactory;
import tools.descartes.dql.models.mapping.domain.Entity;
import tools.descartes.dql.models.mapping.domain.Probe;
import tools.descartes.dql.models.mapping.domain.StatType;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;
import tools.descartes.dql.models.mapping.mapping.MappingFactory;
import tools.descartes.dql.models.mapping.mapping.impl.MappingFactoryImpl;

public class CpuUtilizationTest {
	
	@Test
	public void testCpuUtilizationAnalysis(){

		String modelLocation = "testFiles";
		
		PerformanceMetricsQueryConnectorImpl pmqc = new PerformanceMetricsQueryConnectorImpl();
		
		//Build request
		MappingFactory mappingFactory = MappingFactoryImpl.init();
		EntityMapping request = mappingFactory.createEntityMapping();
		request.setModelLocation(modelLocation);
		Entity res1 = DomainFactory.eINSTANCE.createEntity();
		res1.setEntityType("RESOURCE");
		Probe p = DomainFactory.eINSTANCE.createProbe();
		p.setMetricName("utilization");
		StatType st = DomainFactory.eINSTANCE.createStatType();
		st.setTypeName("SAMPLE");
		p.getStatTypes().add(st);
		res1.getProbes().add(p);
		res1.setAlias("res1");
		res1.setIdentifier("cpu1");
		request.getEntities().add(res1);
		
		EntityMapping answer = pmqc.requestMetrics(request);
		ContinuousSeriesResult r = (ContinuousSeriesResult) answer.getEntities().get(0).getProbes().get(0).getStatTypes().get(0).getResult();
		assertTrue(r.getValid());	
		assertTrue(r.getElements().size() > 0);
	}
}
